$INTERFACE U0FDU1                                             97/12/01
$REM LU
  $N='N'
  $ADD(INTEGER,'\IMD')
  $HELP
    TYPE OF METHOD:
      P - PATTERN SEARCH
      S - SIMPLEX METHOD
  $CHECK(TYPE,'P','P\S',2,NO)
  $IF(TYPE='P') $TYP='PS'
  $IF(TYPE='S') $TYP='SM'
  $IF(TYPE='P')
    $HELP
      NUMBER OF METHOD:
        1 - BASIC PATTERN SEARCH WITH SORTING
    $CHECK(NUMBER,1,'1',2,NO)
  $ELSE
    $NUMBER=1
    $HELP
      NUMBER OF METHOD:
        1 - BASIC SIMPLEX METHOD
        2 - MODIFIED SIMPLEX METHOD
    $CHECK(NUMBER,1,'1\2',2,NO)
  $ENDIF
  $ISNF=0
  $SUBST('UO0FU1')
*
*     ----------------
*     HEURISTIC METHOD
*     TEMPLATE: U0FDU1
*     ----------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',0)
  CALL UYPRO2(FMIN,FO)
  N=NF
$L=$10 ; $LABEL
  $KD=0
  $SUBST('UZMODL')
  GO TO IMD
$L=$20 ; $LABEL
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF(ITERM.NE.0) GOTO $50
$L=$30 ; $LABEL
  ASSIGN $30 TO IMD
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDD$(TYP)$NUMBER
*     -----------------------
*
  $SUBST('UDD$(TYP)$NUMBER')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  GOTO ($40,$10) ISB+1
$L=$40 ; $LABEL
  ASSIGN $40 TO IMD
  $SUBST('US0$(TYP)$NUMBER')
  GOTO ($45,$10) ISB+1
$L=$45 ; $LABEL
  TXFU=TUXX
  IF(ITERM.EQ.0) GOTO $20
  TXFU=TDXX
$L=$50 ; $LABEL
  CALL UYEPI1(0)
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U0FDU1'
  $ENDADD
  $EXIT
