$INTERFACE U1ASI1                                             16/12/01
$REM LU
  $OPTION(LPERFD=.TRUE.)
  $GF='GF'
  $ADD(INTEGER,'\NFO\NCO\MCO\IMS\J\K\L')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
  $HELP
    REPRESENTATION OF THE ADDITIONAL VARIABLES
      0 - LINEAR
      1 - NONLINEAR
  $CHECK(MEP5,0,'0\1',2)
  $IF(NC=0)
    $MC=0
    $MCH=0
    $KDC=KDA
    $KBC=1
    $CU=CL
    $FMODC='X'
    $GMODC='X'
    $IF($DEF(FMODELA))
      $SET(FMODELC)
*       NEW FMODELC
      $ENDSET
      $FMODC='F'
    $ENDIF
    $IF($DEF(GMODELA))
      $SET(GMODELC)
*       NEW GMODELC
      $ENDSET
      $GMODC='G'
    $ENDIF
    $IF($DEF(FGMODELA))
      $SET(FGMODELC)
*       NEW FGMODELC
      $ENDSET
      $FMODC='FG'
    $ENDIF
    $CRED='NO'
    $MODELC='YES'
    $LDC=-1
$REM    $SUBST('UZMODC')
  $ENDIF
  KBC=$KBC
  $NFO=NF
  $NXO=NX
  $NCO=NC
  $MCO=MC
  $ADD(SINIT)
    CALL UXVINP(NF+NA+1,$IH)
    CALL UXVINP(NF+NA,$JH)
  $ENDADD
  $ADD(SINID)
*
*     -----------------------------
*     TRANSORMATION OF L1 NORM TO A
*     NONLINEAR PROGRAMMING PROBLEM
*     TEMPLATE : U1ASI1
*     -----------------------------
*
    IF (NC.EQ.0) MC=0
    NFO=NF
    NCO=NC
    MCO=MC
    CALL UXVSET(NA,0.0$P 0,$X(NF+1))
    NF=NF+NA
    CALL UXVINS(NA,2,$IC(NC+1))
    CALL UXVSET(NA,ZERO,$CU(NC+1))
    CALL UXVICP(MA,$JAG,$JCG(MC+1))
    DO $10 KA=1,NA+1
    $ICG(NC+KA)=MC+$IAG(KA)
$10 CONTINUE
    MC=NF
    DO $30 KC=NA,1,-1
    K=$ICG(KC+NC)
    L=$ICG(KC+NC+1)-1
    DO $20 J=L,K,-1
    $JCG(J+KC-1)=$JCG(J)
$20 CONTINUE
    $JCG(L+KC)=MC
    $ICG(KC+NC+1)=$ICG(KC+NC+1)+KC
    MC=MC-1
$30 CONTINUE
    NC=NC+NA
    MC=$ICG(NC+1)-1
    CALL UXVINS(NA,1,$IC(NC+1))
    CALL UXVSET(NA,ZERO,$CL(NC+1))
    CALL UXVICP(MC-MCO,$JCG($ICG(NCO+1)),$JCG($ICG(NC+1)))
    DO $40 KA=NA+1,1,-1
    $ICG(NC+KA)=MC-MCO+$ICG(NCO+KA)
$40 CONTINUE
    NC=NC+NA
    MC=$ICG(NC+1)-1
    MA=NA
    MAH=NA
    CALL UXVINP(NA+1,IBG)
    $IF(MEP5=0)
      NAL=NA
      DO $45 KA=1,NA
      JBG(KA)=NFO+KA
      $AG(KA)=ONE
$45   CONTINUE
    $ELSE
      NAL=0
      DO $45 KA=1,NA
      JBG(KA)=NFO+KA
$45   CONTINUE
    $ENDIF
    $SUBST('UFSET5')
  $ENDADD
  $IF($DEF(MCH))
    $IF($DEF(MAH))
      $MCH='$MCH+2*$MAH'
    $ENDIF
  $ENDIF
  $SUBST('UCSUM1')
  $NF='$NF+$NA'
  $NX=NF
  $NCP=NC
  $NC='$NC+2*$NA'
  $MC='$MC+2*$MA'
  $MA=NA
  $MAH=NA
  $IAGS=IAG
  $JAGS=JAG
  $IAG='IBG'
  $JAG='JBG'
  $JACA='S'
  $IF(MEP5=0)
    $NAL=NA
  $ELSE
    $NAL=0
    $SET(FMODELA)
      FA=X(NFO+KA)
    $ENDSET
    $SET(GMODELA)
      GA(NFO+KA)=ONE
    $ENDSET
    $KDA=1
  $ENDIF
  $MCOLS=NF
  $OPTION(LPERFD=.FALSE.)
  $SUBST('U1F$(FORM)1')
  $NF=NFO
  $NX=NXO
  $NC=NCO
  $MC=MCO
  NF=NFO
  NC=NCO
  MC=MCO
  $IAG=IAGS
  $JAG=JAGS
  $ADD(INIT)
    NXFU='U1ASI1'
  $ENDADD
  $EXIT
