$INTERFACE UDLLN1                                             05/12/01
$REM LU
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0D-3',REAL,4)
  $ADD(REAL,'\$GN($NF)\$SN($NF)')
  $ADD(REAL,'\ALF\BET')
  CALL UOD1D1
  $ADD(REAL,'\UXUDOT')
  $POM1='U'
  $POM2=',$$IX,KBF)'
  $N='NF'
  $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$XR($MF*($MF+1)/2)&
  \$GR($MF*($MF+1)/2)\$HR($MF*($MF+1)/2)\$XM1($NF*$MF)\$GM1($NF*$MF)&
  \$XR1($MF*($MF+1)/2)\$GR1($MF*($MF+1)/2)\$HR1($MF*($MF+1)/2)\$XO($NF)')
  $ADD(INTEGER,'\$IX($NX)\NN\NN1')
  $IDECF=9
  IDECF=9
  INF=0
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
*
*     NEWTON LIKE STEP
*
  CALL UX$(POM1)NEG($N,$GN,$XO$POM2
  CALL UXLSIN($N,NN,NN1,$XM,$GM,$GR,$HR,$XM1,$GM1,$HR1,$U1,$U2&
,$XO,$SN,PAR3)
  INITD=MAX(ABS(INITD),1)
  ITERD=1
  IF(INF.EQ.0) THEN
  TDXX(5:8)=' POS'
  ELSEIF(INF.LT.0) THEN
  TDXX(5:8)=' ZER'
  ELSE
  TDXX(5:8)=' NEG'
  ENDIF
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  NRED=INF
  CALL UOD1D5(ALF,BET,INF)
$30 CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UDLLN1'
  $ENDADD
  $EXIT
