$INTERFACE UYRMB1                                            98/12/01
  $HELP
    OPTION FOR CONSTRAINT DELETION
      0 - SINGLE CONSTRAINT DELETION
      1 - SIMULTANEOUS CONSTRAINT DELETION
  $CHECK(IREM,0,'0\1',4,NO)
  $HELP
    OPTION FOR DELETION OF LINEARLY DEPENDENT CONSTRAINTS
      0 - NO DELETION
      1 - DELETION OF LINEARLY DEPENDENT CONSTRAINTS
  $CHECK(MLC2,1,'0\1',4,NO)
  $HELP
    TOLERANCE FOR CONSTRAINTS TO BE REMOVED
  $CHECK(EPS8,'0.5$P 0',REAL,4)
  $IF(IREM>0)
$00 CONTINUE
  $ENDIF
  CALL UYRMB1(NF,N,MCL,$IX,$XN,$IC,$ICA,$CG,$CR,$CZ,$G,$GN,$H,EPS8&
,UMAX,GMAX,IOLD,KOLD,KREM,IER)
  $IF(IREM>0)
    IF (IOLD.NE.0) THEN
    CALL UYTRBG(NF,N,MCL,$IX,$XN,$IC,$ICA,$CG,$CR,$CZ,$G,$GN,UMAX,GMAX&
,IOLD)
    GO TO $00
    ENDIF
  $ENDIF
  $IF(MLC2=0)
    KREM=0
  $ENDIF
  $ADD(REAL,'\$XN($NF)\$CG($NF*$MCL)\$CR($NF*($NF+1)/2)\$CZ($NF*$NF)&
  \$G($NF)\$GN($NF)\$H($NF*($NF+1)/2)')
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)\$ICA($NF)')
$REM  $ADD(INTEGER,'\NF\N\MCL\IOLD\KOLD\KREM\IER')
$REM  $ADD(REAL,'\UMAX\GMAX')
  $EXIT
