$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZTEST                                     01/12/91 +
$REM + SI                                                            +
$REM + PURPOSE:  TEST OF MODEL                                       +
$REM +---------------------------------------------------------------+

$IF(TEST='NO') $EXIT

$SUBST('UOT0F1')
$NMET2=$NMET
$IF(TEST='ONLY')
  $IF(KBF>0)
    $ADD(INTEGER,'\$IX($NF)')
    $ADD(REAL,'\$XL($NF)\$XU($NF)')
  $ENDIF
  $IF(KBC>0)
    $ADD(INTEGER,'\$IC($NC)')
    $ADD(REAL,'\$CL($NC)\$CU($NC)')
  $ENDIF
  $IF($DEF(NCL))
    $IF(NCL>0)
      $IF(JACC='S')
        $ADD(REAL,'\$CG($MC)')
        $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)')
      $ELSE
        $ADD(REAL,'\$CG($NF*$NC)')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KBA>0)
    $ADD(REAL,'\$AM($NA)')
  $ENDIF
  $IF($DEF(NAL))
    $IF(NAL>0)
      $IF(JACA='S')
        $ADD(REAL,'\$AG($MA)')
        $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
      $ELSE
        $ADD(REAL,'\$AG($NF*$NA)')
      $ENDIF
    $ENDIF
  $ENDIF
$ELSE
  $NMET=0
$ENDIF
$IF(KDF>0)
  $DDEF=0
  $IF(DMODF='D') $DDEF=1
  $IF(GMODF='GD') $DDEF=1
  $IF(FMODF='FD') $DDEF=1
  $IF(FMODF='FGD') $DDEF=1
  $IF(HESF='S')
    $ADD(INTEGER,'\$IH($NF+1)\$JH($M)')
  $ENDIF
  $SUBST('UTM$(KDF)F1')
$ENDIF
$IF(KDA>0)
  $DDEF=0
  $IF(DMODA='D') $DDEF=1
  $IF(GMODA='GD') $DDEF=1
  $IF(FMODA='FD') $DDEF=1
  $IF(FMODA='FGD') $DDEF=1
  $HELP
    EXTENT OF THE STANDARD TEST:
      N - ONLY APPROXIMATED FUNCTIONS
      Y - OBJECTIVE FUNCTION AND APPROXIMATED FUNCTIONS
      O - ONLY OBJECTIVE FUNCTION
  $CHECK(OBJF,'N','NO\N\YES\Y\ONLY\O',1,NO)
  $IF(OBJF='N') $OBJF='NO'
  $IF(OBJF='Y') $OBJF='YES'
  $IF(OBJF='O') $OBJF='ONLY'
  $IF(OBJF<>'NO') $SUBST('UTM$(KDA)F2')
  $IF(OBJF<>'ONLY')
    $NUM=1
    $IF(JACA='S')
      $NUM=3
      $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
      $IF($DEF(ISNA))
      $ELSE
        $ISNA=-1
      $ENDIF
      $ISNAS=ISNA
    $ENDIF
    $IF($DEF(IDA)) $ERASE(IDA)
    $IF(LDA=0)
      $IF(KDA>0)
        $IDA=1
      $ENDIF
    $ELSEIF(LDA>0)
      $IF(KDA>1)
        $IDA=2
      $ELSEIF(KDA>0)
        $IDA=1
      $ENDIF
    $ENDIF
    $IF ($DEF(IDA)) $SUBST('UTS$(IDA)A$NUM')
    $SUBST('UTM$(KDA)A$NUM')
  $ENDIF
$ENDIF
$IF(KDC>0)
  $NUM=1
  $IF(JACC='S')
    $NUM=3
    $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)')
  $ENDIF
  $IF($DEF(IDC)) $ERASE(IDC)
  $IF(LDC=0)
    $IF(KDC>0)
      $IDC=1
    $ENDIF
  $ELSEIF(LDC>0)
    $IF(KDC>1)
      $IDC=2
    $ELSEIF(KDC>0)
      $IDC=1
    $ENDIF
  $ENDIF
  $IF ($DEF(IDC)) $SUBST('UTS$(IDC)C$NUM')
  $SUBST('UTM$(KDC)C$NUM')
  $IF(ISNC<0) $ERASE(ISNC)
$ENDIF
$IF(KDY>0)
  $NUM=1
  $IF($DEF(IDY)) $ERASE(IDY)
  $IF(LDY=0)
    $IF(KDY>0)
      $IDY=1
    $ENDIF
  $ELSEIF(LDY>0)
    $IF(KDY>1)
      $IDY=2
    $ELSEIF(KDY>0)
      $IDY=1
    $ENDIF
  $ENDIF
  $IF ($DEF(IDY)) $SUBST('UTS$(IDY)Y$NUM')
  $SUBST('UTM$(KDY)Y1')
$ENDIF
$IF(KDE>0)
  $GDEF=0
  $DDEF=0
  $IF(GMODE='G') $GDEF=1
  $IF(DMODE='D') $DDEF=1
  $IF(GMODE='GD') $GDEF=1
  $IF(GMODE='GD') $DDEF=1
  $IF(FMODE='FG') $GDEF=1
  $IF(FMODE='FD') $DDEF=1
  $IF(FMODE='FGD') $GDEF=1
  $IF(FMODE='FGD') $DDEF=1
  $NUM=1
  $IF($DEF(IDE)) $ERASE(IDE)
  $IF(LDE=0)
    $IF(KDE>0)
      $IDE=1
    $ENDIF
  $ELSEIF(LDE>0)
    $IF(KDE>1)
      $IDE=2
    $ELSEIF(KDE>0)
      $IDE=1
    $ENDIF
  $ENDIF
  $IF ($DEF(IDE)) $SUBST('UTS$(IDE)E$NUM')
  $SUBST('UTM$(KDE)E1')
$ENDIF
$NMET=$NMET2
