$INTERFACE ULLPI1                                             98/12/01
     $HELP
       INTERIOR POINT METHOD
         1 - JIANMING MIAO ALGORITHM 1
         2 - JIANMING MIAO ALGORITHM 2
         3 - MIZUNO ALGORITHM
     $CHECK(MLP,1,'1\2\3',3)
     $HELP
       LOWER BOUND FOR STEPLENGTH
     $CHECK(TOLX,'1.0$P-8',REAL,3)
     $HELP
       LOWER BOUND FOR CONSTRAINT VIOLATION
     $CHECK(TOLC,'1.0$P-6',REAL,3)
     $HELP
       LOWER BOUND FOR GRADIENT OF THE
       LAGRANGIAN FUNCTION
     $CHECK(TOLG,'1.0$P-6',REAL,3)
 $00 CALL ULLPI1(NF,NC,MC,$GF,$CG,$ICG,$JCG,$CL,$X,$CZ,$G,$CF,$D,$SO,$S&
,$XS,$GS,CMAX,GMAX,UMAX,RPF1,$MLP,MRED,INEW)
     GO TO ($20,$10) ISB+1
 $10 CONTINUE
     $IF(NUMBER=2) CALL UXVNEG(NF,$D,$H)
     $SUBST('UDSLL$NUMBER')
     GOTO $00
 $20 CONTINUE
     $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)')
     $ADD(REAL,'\$GF($NF)\$CG($MC)\$CL($NC)\$X($NF)\$CZ($NC)\$G($NF)&
     \$CF($NC)\$D($NF)\$SO($NF)\$S(2*$NF+$NC)\$XS(2*$NF)\$GS($NF)')
     $ADD(INIT)
       NLPX='ULLPI1'
     $ENDADD
     $EXIT
